!---------------------------------------------------------------------
!---------------------------------------------------------------------
!		A linear ODE eigenvalue problem
!---------------------------------------------------------------------
!---------------------------------------------------------------------

 SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP)
!---------- ----

 IMPLICIT NONE
 INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
 DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
 DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
 DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM), DFDP(NDIM,*)

 DOUBLE PRECISION lambda, pi, u1, u2

   pi = 4*DATAN(1.d0)
   lambda = PAR(1)

   u1 = U(1)
   u2 = U(2)

   F(1) = u2
   F(2) =-( lambda*pi )**2 * u1

 END SUBROUTINE FUNC
!---------------------------------------------------------------------

 SUBROUTINE STPNT(NDIM,U,PAR,T)
!---------- -----

 IMPLICIT NONE
 INTEGER, INTENT(IN) :: NDIM
 DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
 DOUBLE PRECISION, INTENT(IN) :: T

 DOUBLE PRECISION lambda, beta, gamma, u1, u2

   lambda = 0.d0
   beta   = 0.d0
   gamma  = 0.d0

   PAR(1) = lambda
   PAR(2) = beta
   PAR(3) = gamma

   u1 = 0.d0
   u2 = 0.d0

   U(1) = u1
   U(2) = u2

 END SUBROUTINE STPNT
!---------------------------------------------------------------------

 SUBROUTINE BCND(NDIM,PAR,ICP,NBC,U0,U1,FB,IJAC,DBC)
!---------- ----

 IMPLICIT NONE
 INTEGER, INTENT(IN) :: NDIM, ICP(*), NBC, IJAC
 DOUBLE PRECISION, INTENT(IN) :: PAR(*), U0(NDIM), U1(NDIM)
 DOUBLE PRECISION, INTENT(OUT) :: FB(NBC)
 DOUBLE PRECISION, INTENT(INOUT) :: DBC(NBC,*)

 DOUBLE PRECISION beta

   beta = PAR(2)

   FB(1) = U0(1) - beta
   FB(2) = U1(1)

 END SUBROUTINE BCND
!---------------------------------------------------------------------

 SUBROUTINE ICND(NDIM,PAR,ICP,NINT,U,UOLD,UDOT,UPOLD,FI,IJAC,DINT)
!---------- ----

 IMPLICIT NONE
 INTEGER, INTENT(IN) :: NDIM, ICP(*), NINT, IJAC
 DOUBLE PRECISION, INTENT(IN) :: PAR(*)
 DOUBLE PRECISION, INTENT(IN) :: U(NDIM), UOLD(NDIM), UDOT(NDIM), UPOLD(NDIM)
 DOUBLE PRECISION, INTENT(OUT) :: FI(NINT)
 DOUBLE PRECISION, INTENT(INOUT) :: DINT(NINT,*)

 DOUBLE PRECISION gamma, u1

   gamma = PAR(3)
   u1 = U(1)

   FI(1) = u1**2 - gamma

 END SUBROUTINE ICND
!---------------------------------------------------------------------
!---------------------------------------------------------------------
 SUBROUTINE FOPT
 END SUBROUTINE FOPT

 SUBROUTINE PVLS
 END SUBROUTINE PVLS
!---------------------------------------------------------------------
!---------------------------------------------------------------------
