!----------------------------------------------------------------------
!----------------------------------------------------------------------
!      Spurious solutions to a boundary value problem
!----------------------------------------------------------------------
!----------------------------------------------------------------------

 SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP)
!---------- ----

 IMPLICIT NONE
 INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
 DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
 DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
 DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM), DFDP(NDIM,*)

 DOUBLE PRECISION pi, lambda, u1, u2, p

   pi=4*DATAN(1.d0)

   lambda = PAR(1)

   u1 = U(1)
   u2 = U(2)
   p = u1 + u1**2 + u1**3

   F(1)= u2
   F(2)=-lambda**2 * pi**2 * DSIN(p)

 END SUBROUTINE FUNC
!----------------------------------------------------------------------

 SUBROUTINE STPNT(NDIM,U,PAR,T)
!---------- -----

 IMPLICIT NONE
 INTEGER, INTENT(IN) :: NDIM
 DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
 DOUBLE PRECISION, INTENT(IN) :: T

   PAR(1) = 0.d0

   U(1) = 0.d0
   U(2) = 0.d0

 END SUBROUTINE STPNT
!----------------------------------------------------------------------

 SUBROUTINE BCND(NDIM,PAR,ICP,NBC,U0,U1,FB,IJAC,DBC)
!---------- ----

 IMPLICIT NONE
 INTEGER, INTENT(IN) :: NDIM, ICP(*), NBC, IJAC
 DOUBLE PRECISION, INTENT(IN) :: PAR(*), U0(NDIM), U1(NDIM)
 DOUBLE PRECISION, INTENT(OUT) :: FB(NBC)
 DOUBLE PRECISION, INTENT(INOUT) :: DBC(NBC,*)

   FB(1) = U0(1)
   FB(2) = U1(1)

 END SUBROUTINE BCND
!----------------------------------------------------------------------

 SUBROUTINE PVLS(NDIM,U,PAR)
!---------- ----

 IMPLICIT NONE
 INTEGER, INTENT(IN) :: NDIM
 DOUBLE PRECISION, INTENT(IN) :: U(NDIM)
 DOUBLE PRECISION, INTENT(INOUT) :: PAR(*)
 DOUBLE PRECISION, EXTERNAL :: GETP,GETU2

 DOUBLE PRECISION gamma

!  Set gamma equal to the value of u2 at the left boundary:
   gamma = GETP('BV0',2,U)
   PAR(2) = gamma

 END SUBROUTINE PVLS

!----------------------------------------------------------------------
!----------------------------------------------------------------------
 SUBROUTINE ICND
 END SUBROUTINE ICND

 SUBROUTINE FOPT
 END SUBROUTINE FOPT
!----------------------------------------------------------------------
